Trajectory
Date: 2019-10-22

org.jmol.modelset

## Class Trajectory

- java.lang.Object
- - org.jmol.modelset.Trajectory

-     public class Trajectory
      extends java.lang.Object

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `(package private) boolean` | `isFractional`
    `(package private) ModelSet` | `ms`
    `(package private) javajs.util.Lst<javajs.util.P3[]>` | `steps`
    `private Viewer` | `vwr`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Trajectory()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `(package private) void` | `fixAtom(Atom a)`
    `void` | `getFractional(Atom a, javajs.util.P3 ptTemp)`
    `void` | `getModelBS(int modelIndex, javajs.util.BS bs)` set bits for all trajectories associated with this model
    `(package private) javajs.util.BS` | `getModelsSelected()`
    `java.lang.String` | `getState()`
    `boolean` | `hasMeasure(int[] measure)`
    `(package private) void` | `morph(int m1, int m2, float f)`
    `void` | `selectDisplayed(javajs.util.BS bs)` Remove trajectories that are not currently displayed from the visible frames bitset.
    `(package private) Trajectory` | `set(Viewer vwr, ModelSet ms, javajs.util.Lst<javajs.util.P3[]> steps)`
    `private void` | `setAtomPositions(int baseModelIndex, int modelIndex, javajs.util.P3[] t1, javajs.util.P3[] t2, float f, javajs.util.V3[] vibs, boolean isFractional)` A generic way to set atom positions, possibly from trajectories but also possibly from an array.
    `void` | `setBaseModels(javajs.util.BS bsModels)` set bits for all base models only
    `(package private) void` | `setModel(int modelIndex)` The user has used the MODEL command to switch to a new set of atom coordinates Or has specified a trajectory in a select, display, or hide command.
    `(package private) void` | `setUnitCell(int imodel)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### vwr

          private Viewer vwr

    - #### ms

          ModelSet ms

    - #### steps

          javajs.util.Lst<javajs.util.P3[]> steps

    - #### isFractional

          boolean isFractional

  - ### Constructor Detail

    - #### Trajectory

          public Trajectory()

  - ### Method Detail

    - #### set

          Trajectory set(Viewer vwr,
                         ModelSet ms,
                         javajs.util.Lst<javajs.util.P3[]> steps)

    - #### setUnitCell

          void setUnitCell(int imodel)

    - #### setModel

          void setModel(int modelIndex)

      The user has used the MODEL command to switch to a new set of atom coordinates Or has specified a trajectory in a select, display, or hide command. Assign the coordinates and the model index for this set of atoms
      Parameters:
        `modelIndex` -

    - #### setAtomPositions

          private void setAtomPositions(int baseModelIndex,
                                        int modelIndex,
                                        javajs.util.P3[] t1,
                                        javajs.util.P3[] t2,
                                        float f,
                                        javajs.util.V3[] vibs,
                                        boolean isFractional)

      A generic way to set atom positions, possibly from trajectories but also possibly from an array. Takes care of all associated issues of changing coordinates.
      Parameters:
        `baseModelIndex` -
        `modelIndex` -
        `t1` -
        `t2` -
        `f` -
        `vibs` -
        `isFractional` -

    - #### getModelsSelected

          javajs.util.BS getModelsSelected()

    - #### morph

          void morph(int m1,
                     int m2,
                     float f)

    - #### fixAtom

          void fixAtom(Atom a)

    - #### getFractional

          public void getFractional(Atom a,
                                    javajs.util.P3 ptTemp)

    - #### getState

          public java.lang.String getState()

    - #### hasMeasure

          public boolean hasMeasure(int[] measure)

    - #### selectDisplayed

          public void selectDisplayed(javajs.util.BS bs)

      Remove trajectories that are not currently displayed from the visible frames bitset. when a trajectory is selected, the atom's modelIndex is switched to that of the selected trajectory even though the underlying model itself is not changed.
      Parameters:
        `bs` -

    - #### getModelBS

          public void getModelBS(int modelIndex,
                                 javajs.util.BS bs)

      set bits for all trajectories associated with this model
      Parameters:
        `modelIndex` -
        `bs` -

    - #### setBaseModels

          public void setBaseModels(javajs.util.BS bsModels)

      set bits for all base models only
      Parameters:
        `bsModels` -